local path = ('__TronLegacy-LightCycle__')
local sounds = require("__base__.prototypes.entity.sounds")

local function make_laser_sounds(volume)
  local base_sound_path = "__base__/sound/fight/"
  return
  {
      {
          filename = base_sound_path .. "laser-1.ogg",
          volume = volume or 0.5,
          speed = 0.1
      },
      {
          filename = base_sound_path .. "laser-2.ogg",
          volume = volume or 0.5,
          speed = 0.1
      },
      {
          filename = base_sound_path .. "laser-3.ogg",
          volume = volume or 0.5,
          speed = 0.1
      }
  }
end
data:extend({
  {
    type = "item-with-entity-data",
    name = "tron-lightcycle",
    icon = path .. "/graphics/icons/tron64.png",
    icon_size = 64, icon_mipmaps = 4,
    subgroup = "transport",
    order = "b[personal-transport]-b[tank]",
    place_result = "tron-lightcycle",
    stack_size = 1
  },
  {
    type = "recipe",
    name = "tron-lightcycle",
    enabled = false,
    energy_required = 50,
    ingredients =
    {
      {type = "item", name = "engine-unit", amount = 8},
      {type = "item", name = "steel-plate", amount = 15},
      {type = "item", name = "advanced-circuit", amount = 5}
    },
    results = {{type = "item", name = "tron-lightcycle", amount = 1}}
  },
  {
    type = "recipe",
    name = "encom-laser-cell",
    enabled = false,
    energy_required = 10, 
    ingredients =
    {
      {type = "item", name = "steel-plate", amount = 20}, 
      {type = "item", name = "advanced-circuit", amount = 10}, 
      {type = "item", name = "battery", amount = 25} 
    },
    results = {{type = "item", name = "encom-laser-cell", amount = 1}}
  },
  {
    type = "recipe",
    name = "encom-energy-cell",
    energy_required = 30, 
    enabled = false,
    ingredients =
    {
      {type = "item", name = "battery", amount = 150}, 
      {type = "item", name = "steel-plate", amount = 5}, 
      {type = "item", name = "copper-cable", amount = 10}, 
      {type = "item", name = "advanced-circuit", amount = 5} 
    },
    results = {{type = "item", name = "encom-energy-cell", amount = 1}}
  },
  {
    type = "recipe",
    name = "deconstruct-encom-cell",
    energy_required = 30,
    enabled = false,
    ingredients = 
    {
      {type = "item", name = "encom-energy-cell", amount = 1},
      {type = "item", name = "repair-pack", amount = 1}
    },
    results = {{type = "item", name = "empty-encom-energy-cell", amount = 75}}
  },
  {
    type = "recipe",
    name = "encom-cell-recharge",
    energy_required = 35, 
    enabled = false,
    ingredients = 
    {
      {type = "item", name = "empty-encom-energy-cell", amount = 1}, 
      {type = "item", name = "battery", amount = 150} 
    },
    results = {{type = "item", name = "encom-energy-cell", amount = 1}}
  },
  {
    type = "recipe",
    name = "encom-cell-conversion",
    energy_required = 45,
    enabled = false,
    ingredients =
    {
      {type = "item", name = "encom-energy-cell", amount = 1},
      {type = "item", name = "processing-unit", amount = 10},
      {type = "item", name = "low-density-structure", amount = 5}
    },
    results = {{type = "item", name = "battery-mk2-equipment", amount = 1}}
  },
  -- Items
  {
    type = "gun",
    name = "tronlaser",
    icon = path .. "/graphics/icons/tront64.png",
    icon_size = 64,
    attack_parameters =
    {
      type = "beam",
      ammo_category = "laser",
      cooldown = 10,
      range = 24,
      source_direction_count = 64,
      source_offset = {0, 0},
      damage_modifier = 5,
      sound = make_laser_sounds(3)
    },
    stack_size = 1
  },
  {
    type = "ammo",
    name = "encom-laser-cell",
    icon = path .. "/graphics/icons/tronammo64.png",
    icon_size = 64,
    magazine_size = 50,
    ammo_category = "laser",
    ammo_type =
    {
      category = "tron-laser-ammo",
      action =
      {
        type = "direct",
        action_delivery =
        {
          type = "beam",
          beam = "laser-beam",
          max_length = 26,
          duration = 40,
          source_direction_count = 64, 
          source_offset = {0, -0.8},
          sound = make_laser_sounds(3)
        }
      }
    },
    subgroup = "ammo",
    stack_size = 100 
  },
  {
    type = "item",
    name = "encom-energy-cell",
    icon = path .. "/graphics/icons/encomcell128.png",
    icon_size = 128,
    fuel_category = "encom-cell",
    fuel_value = "1.21GJ",
    fuel_acceleration_multiplier = 1.8,
    fuel_top_speed_multiplier = 1.15,
    subgroup = "intermediate-product",
    stack_size = 10,
    burnt_result = "empty-encom-energy-cell"
  },
  {
    type = "item",
    name = "empty-encom-energy-cell",
    icon = path .. "/graphics/icons/encomemptycell128.png",
    icon_size = 128,
    fuel_category = "encom-cell",
    fuel_value = "0GJ",
    stack_size = 10
  },
})