local wall_damaged_effect = {
  {
    type = "create-entity",
    entity_name = "grenade-explosion"
  },
  {
    type = "damage",
    damage = { amount = 20, type = "explosion" }
  }
}

--- @type data.SimpleEntityPrototype
local wall = {
  type = "simple-entity-with-owner",
  name = "tron-wall",
  flags = { "placeable-off-grid" },
  collision_box = {{-0.25, -0.25}, {0.25, 0.25}},
  attack_reaction = {
    {
      range = 10.0, -- units within this range trigger reaction
      action = {
        type = "direct",
        action_delivery = {
          type = "instant",
          target_effects = {
            {
              type = "damage",
              damage = { amount = 10, type = "physical" }
            }
          }
        }
      },
      reaction_modifier = 1.0,
      damage_type = "physical"
    }
  },
  damaged_trigger_effect = wall_damaged_effect,
  healing_per_tick = -0.1,
  animations = {},
}

for i = 1, 64 do
  --- @type data.Animation
  local animation = {
    layers = {
      {
        scale = 0.5,
        filename = "__TronLegacy-LightCycle__/graphics/wall/Tronwall_" .. tostring(i) .. ".png",
        blend_mode = "normal",
        width = 64,
        height = 96,
        line_length = 4,
        lines_per_file = 2,
        frame_count = 8,
        apply_runtime_tint = true,
        animation_speed = 1 / 8,
      },
      {
        scale = 0.5,
        filename = "__TronLegacy-LightCycle__/graphics/wall/Tronwallglo_" .. tostring(i) .. ".png",
        width = 64,
        height = 96,
        line_length = 4,
        lines_per_file = 2,
        frame_count = 8,
        apply_runtime_tint = true,
        draw_as_glow = true,
        animation_speed = 1 / 8,
      },
    }
  }
  table.insert(wall.animations, animation);
end

data:extend({ wall })
